<?php
namespace Zeedhi\Framework\DB\StoredProcedure\Strategies;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\DataBaseStrategy;

class StrategyFactory {

    /**
     * @param Connection $connection
     *
     * @return DataBaseStrategy
     *
     * @throws \Exception
     */
    public static function createStrategy(Connection $connection) {
        switch ($connection->getDriver()->getName()) {
            case 'oci8':
            case 'zeedhi_oci8':
                return new OracleStrategy($connection);
            case 'sqlsrv':
                return new SQLServerStrategy($connection);
        }

        throw Exception::unsupportedDriver($connection->getDriver()->getName());
    }
}